{$M 25000,0,655360}
{ tento program program pedvd funkce jednotky UnStrom   }
{ a to zvlt procedury vanim_insert                      }
{ Tato procedura vytvo obdelnkov objekt s klem       }
{ danm parametrem a zatd jej do vyvenho stromu.     }
{ Pot strom znovu vyv.                                 }
{ Zatdn i vyven probh animovan.                  }
{ Pro ukzku je zde uvedena i procedura anim_insert,       }
{ kter zatd prvek stejnm zpsobem, ale strom nevyv }
{ a procedura Vinsert, kter probh neanimovan.          }
{ procedury jsou pevzaty ze skript                        }
{ Ing. Karel Richta, Datov struktury, str. 81             }

uses Obraz3D, Unhejb, Unobdel, Unstrom, Unvokno, Crt, Untimer, Unpisbmp, Unmenu;
const Maxcislo             = 900; { nejvy slo ve strom }
      Kolikzatridit        = 127; { poet prvk stromu }
      Metoda     : Byte    = 1;   { poten metoda, viz case v programu }
      Poc_Pom    : Integer = 10;  { poten pomalost pi animaci }
      __Velikost : Integer = 70;  { poten velikost stromu }
      Jit_Ven    : Boolean = False;

      { program pro menu - stle se provd Vm0 }
const Cesta      : array[1..3]of Typ_Instrukce = (Vm0, Jmpa0, Endc) ;

type
  Typ_Moje_Menu = object(Typ_Menu_Vyber)
                    procedure Vm0;virtual;
                  end;

const Menudef : string =                  { definin etzec pro menu }
'30 30 -1 15 112 10  33 9  4 1'+          { posice [30, 30,-1] barva textu 15, barva zvyraznnho dku 112, barva rmeku 10}
                                                   { rozmr 30x11, 6 prvk, zatek na tvrtm }
'delay~ i 62 30 3  10 10 96  10  1 400  1'+      { editace sla, posice [62, 30, 3], barva textu 10, barva rmeku 10,
                                                   { zvraznn text t 96, poten hodnota 40, minimum 1 a maximum 400 }
'tree size~ i 62 31 3  10 10 96  70  20 100  1'+ { editace sla, posice [62, 31, 3], barva textu 10, barva rmeku 10,
                                                   { zvraznn text t 96, poten hodnota 40, minimum 1 a maximum 400 }
'~ v 31 15 9 15 112 10 33 5 3 1'+
  'animated insert vith balancing~o'+
  'animated insert~o'+
  'insert vith balancing~o'+
'end~o';

var  I, J   : Word;         { pomocn promnn }
     Strom  : Vtyp_Strom;   { vyven strom }
     Psaci  : Typ_Vokynko;  { objekt, do ktereho se bude psat instruktan text }
     Cc     : Typ_integer;  { slou pro zobrazen zatiovanho sla  }
     __Menu : Typ_Moje_Menu;{ menu pro vbr monost programu }

procedure Skoncito;
{ zlikviduje ve, co program napchal }
begin
  __Timer.zrus;
  Off_Pisbmp;
  strom.Zrus;
  Cc.Zrus;
  Psaci.Zrus;
  Konec;
  Halt(0);
end;

procedure Typ_Moje_Menu.Vm0;
var C : Word;
    S : string[5];

begin
  if KeyPressed then
    begin
      { pokud je stisknuta klvesa, pete ji a zachov se podle toho, co bylo stisknuto }
      C := Byte(ReadKey);
      if C = 0 then  C := 256* Byte(ReadKey);

      Zpracuj_Key(C);

      if Sub_Menu^[1]^.Out_Hodnota <> Poc_Pom then
        begin { zmna pomalosti }
          Poc_Pom := Sub_Menu^[1]^.Out_Hodnota;
          Unfront.set_Pomalost(Poc_Pom);
        end;

      if Sub_Menu^[2]^.Out_Hodnota <> __Velikost then
        begin { zmna velikosti }
          __Velikost := Sub_Menu^[2]^.Out_Hodnota;
          set_Velikost(__Velikost/100);
          strom.Obnov;
        end;

      if (Sub_Menu^[3]^.Out_Hodnota <> Metoda) then { zmna metody }
        Metoda := Sub_Menu^[3]^.Out_Hodnota;

      if Out_Hodnota = 4 then Jit_Ven := True; { konec zatiovn }
      case C of
        50 : Cc.D;
        52 : Cc.L;
        54 : Cc.R;
        56 : Cc.U;
        43 : Cc.F;
        45 : Cc.B;
      end;
      set_pocatek_animace(cc.poloha.x,cc.poloha.y,cc.poloha.z);
    end;
end;

begin
  Obrazovka.Nastav_mod(3+__Sada_3D_8X8);   { hezk sada znak }

  strom.Init;                    { inicialisace stomu }
  strom.Presun(0, Obrazovka.Y_Obr shr 1-1, 0); { pesun stromu do 1/2 obrazovky }

  { inicialisace __Menu pomoc defininho etzce }
  I := 0;

  __Menu.Init(@Menudef[1], I);
  __Menu.Otevri;

         { pi asovm peruen se nad __Menu vykonv Vm0 }
  __Menu.Hejbej(Cesta);
  __Timer.Zarad_Prvek(__Menu);

  __Menu.GotoXY(1, 5);
  __Menu.Pis('Inserted element :');

  Cc.Init; { inicialisace a pesun zobrazovacho prvku do __Menu (polohov) }
  Cc.Presun(__Menu.Poloha.X+21,__Menu.Poloha.Y+4,0);
           
  __Timer.On;{ zapnut asov fronty }

  On_Pisbmp;{ zapnut zpisu obrazovky na peruen PrScr - viz UnPisBMP }
  set_Par_Pisbmp('strom', nil);{ obrzky na disku se budou jmenovat strom0.bmp, strom1.bmp atd. }

  Randomize;
  Unfront.set_Pomalost(Poc_Pom); { nastaven poten pomalosti pro animaci }

  set_Pocatek_Animace(__Menu.Poloha.X+21,__Menu.Poloha.Y+4,0); { msto, ze kterho bude vyjdt zat. ptvek }
  for I := 1 to Kolikzatridit do
    begin
      J := Random(Maxcislo)+100;

      Cc.Vytvor(j, 0, 12,12,Strom_Ram);
      Cc.Zobraz; { pomocn zobrazen }

      repeat until Metoda <> 0;
      { nic se nedje, dokud nen zvolena metoda }
      case Metoda of
        1 : strom.Vanim_Insert(J);       { zatdn prvku, vyven }
        2 : strom.Anim_Insert(J);        { zatdn prvku }
        3 : strom.Vinsert(J);            { zatdn prvku, vyven }
      end;
      if Jit_Ven then i:=kolikzatridit; { Jit_Ven se mn v Vm0 __Menu }
    end;

  Psaci.Init;
  Psaci.Presun(0,0+Obrazovka.Y_Obr-15,50);
  Psaci.Vytvor_Ram(80,4,11,14,Strom_Ram);
  Psaci.Zobraz;
  Psaci.set_Psaci_Barva(11);
  Psaci.GotoXY(1,1);
  Psaci.Pis('Pokud nco stisknou, stromecek se prchodem preorder srovn do lajny');
  Psaci.WriteLn;
  Psaci.Pis('Pokud stisknou nic, bude nic ');

  repeat until KeyPressed;
  Psaci.Zhasni;
  strom.Anim_in_Rozmistit;

  Psaci.Zobraz;
  Psaci.GotoXY(1,1);
  Psaci.Pis('Pokud nco stisknou, stromecek se vrt, tentokrt prchodem inorder ');
  repeat until KeyPressed;
  strom.Anim_Obnov;

  Psaci.GotoXY(1,1);
  Psaci.Pis('Pokud nco stisknou, bude konec                                      ');
  repeat until KeyPressed;

  Skoncito;
end.
