unit
  Unmenu;

interface
uses
  Obraz3D, Unhejb, Unvokno, Crt;

const
  __Otevreno            = $01;
  __Zobrazit_Predch     = $02;
  __Platna_Hodnota      = $04;
  __Potvrzena_Hodnota   = $08;

  __Stary_Retez         = $10;
  __Return              = 13;
  __Esc                 = 27;

  __Prava_Sipka         = 77*$100;
  __Leva_Sipka          = 75*$100;
  __Horni_Sipka         = 72*$100;
  __Dolni_Sipka         = 80*$100;

  __Bs                  = 8;
  __Del                 = 83*$100;

  __Home                = 71*$100;
  __end                 = 79*$100;

  __Ctrl_Home           = 119*$100;
  __Ctrl_end            = 117*$100;

  _Lin                  = 0;
  _Spec                 = 1;
  _Exp                  = 2;

type
     Pomchar = array[0..65000]of Char;
     Pompchar = ^Pomchar;
  Typ_Out_Zobraz = string;
  Typ_Int_string = string[7];
  Typ_Zmen_Integer = Byte;
  Typ_Pointer_Menu = ^Typ_Menu;
  Typ_Menu = object (Typ_Vokynko)
               __Stav_Menu : Byte;

   {        x x x x x x x x                                                }
   {        ^ ^ ^ ^ ^ ^ ^ ^                                                }
   {                                                               }
   {               > 1 .. menu bylo oteveno                      }
   {              > 1 .. obsah menu bude zobrazen v ped. rovni }
   {             > 1 .. hodnota je platn                       }
   {            > 1 .. hodnota byla potvrzena                  }
   {           >                                              }
   {          >                                              }
   {         >                                              }
   {        >                                              }

               procedure Zpracuj_Key(_Kt : Word);virtual;
               procedure Pom_set(Co : Integer);virtual;
               procedure Otevri;
               procedure Zavri;
               function Out_Hodnota : Integer;virtual;
               function Out_Zobraz  : Typ_Out_Zobraz;virtual;
               function Otevreno : Boolean;
               function Platna : Boolean;
               function Potvrzeno : Boolean;
               constructor Init;
             end;
  Typ_Pointer_string = ^Typ_Edit_string;

  Typ_Edit_string = object (Typ_Menu)
   {        x x x x x x x x                                                }
   {        ^ ^ ^ ^ ^ ^ ^ ^                                                }
   {           > 1 .. retez je stary                          }
   {          >                                              }
   {         >                                              }
   {        >                                              }

                      __Kursor  : Byte;
                      __Colob, __Colzv : Byte;
                      in_string : ^string;
                      __Delka   : Byte;

                      procedure Vytvor(Sdelka : Byte; Cin, Cram, Czv : Byte;
                                       var Typ);
                      procedure Spust(Defstr : string);
{                      function  out_hodnota : string;virtual;}
                      function  Out_Zobraz  : Typ_Out_Zobraz;virtual;
                      procedure Zpracuj_Key(_Kt : Word);virtual;
                      procedure Otevri;
                      procedure Prekresli;
                      procedure Srovnej_Kursor;

                    end;
  Typ_Pointer_Integer = ^Typ_Edit_Integer;
  Typ_Edit_Integer = object (Typ_Edit_string)
                       in_Num   : Integer;
                       Typ_Zmen : Typ_Zmen_Integer;
                       Min, Max : Integer;
                       procedure Vytvor(Cin, Cram, Czv : Byte; var Typ);
                       procedure Spust(Defnum, _Min, _Max : Integer; _Zmeny : Typ_Zmen_Integer);
                       function Out_Hodnota : Integer;virtual;
                       function Out_Zobraz  : Typ_Out_Zobraz;virtual;
                       procedure Zpracuj_Key(_Kt : Word);virtual;
                       procedure Otevri;
                       function Zvets(Num : Integer) : Integer;
                       function Zmens(Num : Integer) : Integer;
                     end;

type mmoje = array[0..65534]of char;
type pchar = ^mmoje;

type
  Typ_Sub_Menu = array[1..127]of Typ_Pointer_Menu;
  Typ_Pointer_Vyber = ^Typ_Menu_Vyber;
  Typ_Menu_Vyber = object(Typ_Menu)
                     in_Num : Integer;
                     Pocet  : Typ_Souradnic;
                     __Colob, __Colzv : Byte;
                     Oznaceni : Pchar;
                     Sub_Menu : ^Typ_Sub_Menu;
                     procedure Prekresli;
                     constructor Init(Defpop : pchar; var Odposice : Word);
                     procedure Zpracuj_Key(_Kt : Word);virtual;
                     procedure Pom_set(Co : Integer);virtual;
                     procedure Otevri;
                     function Out_Zobraz  : Typ_Out_Zobraz;virtual;
                     function Out_Hodnota : Integer;virtual;
                     procedure Vm0;virtual;
                   end;
implementation

function Typ_Edit_string.Out_Zobraz  : string;
begin
  Out_Zobraz := in_string^ end;

procedure Typ_Edit_string.Zpracuj_Key(_Kt : Word);
var I : Byte;
begin
  if (_Kt=__Return) and (not Otevreno) then Otevri
  else
  if Otevreno then
    begin
      case _Kt of
        __Prava_Sipka : Inc(__Kursor);
        __Leva_Sipka  : Dec(__Kursor);
        __Home        : __Kursor := 1;
        __end         : __Kursor := Length(in_string^)+1;
        __Bs          : if __Kursor > 1 then
                          begin
                            Dec(__Kursor);
                            for I := __Kursor to Byte(in_string^[0]) do
                              in_string^[I] := in_string^[I+1];Dec(in_string^[0]);
                          end;
        __Return      : begin
                          Zavri;
                          __Stav_Menu := __Stav_Menu or __Platna_Hodnota;
                        end;
        __Esc         : Zavri;

        32..127       :
          if Length(in_string^) < __Delka-1 then
            begin
              if (__Stav_Menu and __Stary_Retez) <> 0 then
                begin
                  __Kursor     := 1;
                  in_string^[0] := #0;
                end;

              for I := __Kursor to Length(in_string^) do
                in_string^[I+1] := in_string^[I];
              in_string^[__Kursor] := Char(_Kt);
              Inc(in_string^[0]);
              Inc(__Kursor);
            end;
      end;
      __Stav_Menu :=  (__Stary_Retez xor $Ff) and __Stav_Menu;
      Prekresli;
    end;
end;

procedure Typ_Edit_string.Prekresli;
var C, I : Typ_Souradnic;
begin
  Psaci_Barva := __Colob;
  Clear;
  if (__Stav_Menu and __Stary_Retez) <> 0
    then Psaci_Barva := __Colzv
    else Psaci_Barva := __Colob;
  GotoXY(1,1);Pis(in_string^);
  Obnov;
  if Otevreno then Srovnej_Kursor;
end;

procedure Typ_Edit_string.Srovnej_Kursor;
begin
  if __Kursor > Length(in_string^)+1 then __Kursor := Length(in_string^)+1;
  if __Kursor < 1 then __Kursor := 1;
  Kursor.X := __Kursor;
  Kursor.Y := 1;
  Typ_Vokynko. Srovnej_Kursor;
end;

procedure Typ_Edit_string.Otevri;
begin
  __Stav_Menu :=  __Stary_Retez or __Stav_Menu;
  __Kursor := Length(in_string^)+1;

  Typ_Menu.Otevri;
  Prekresli;
end;


procedure Typ_Edit_string.Vytvor;
begin
  __Colob := Cin;
  __Colzv := Czv;
  Typ_Vokynko.Vytvor_Ram(Sdelka+2,3, Cin, Cram, Typ);
  GetMem(in_string, Sdelka);
  __Delka := Sdelka;
end;

procedure Typ_Edit_string.Spust;
begin
  if Length(Defstr) > __Delka then Defstr[0] := Char(__Delka);
  in_string^ := Defstr;
  __Kursor := Length(in_string^)+1;
  if Otevreno then Prekresli;
end;





function Typ_Edit_Integer.Zvets(Num : Integer) : Integer;
begin
  case Typ_Zmen of
    _Lin  : Inc(Num);
    _Spec : Inc(Num,Num);
    _Exp  : Num := Round(Ln(Max)/Ln(Min)*Num)
  end;

  if Num > Max then Num := Max;
  Zvets := Num;

end;

function Typ_Edit_Integer.Zmens(Num : Integer) : Integer;
begin
  case Typ_Zmen of
    _Lin  : Dec(Num);
    _Spec : Dec(Num, Num shr 1);
    _Exp  : Num := Round(Num/(Ln(Max)/Ln(Min)))
  end;
  if Num < Min then Num := Min;
  Zmens := Num;
end;

function Typ_Edit_Integer.Out_Hodnota : Integer;
begin
  Out_Hodnota := in_Num end;

function Typ_Edit_Integer.Out_Zobraz;
var S : Typ_Int_string;
begin
  Str(in_Num, S); Out_Zobraz := S end;

procedure Typ_Edit_Integer.Zpracuj_Key(_Kt : Word);
var Pom, Code : Integer;
    Pomval : Longint;
    S : Typ_Int_string;
begin

  Pom := in_Num;
  if Otevreno
    then case _Kt of
           __Horni_Sipka : Pom := Zvets(in_Num);
           __Dolni_Sipka : Pom := Zmens(in_Num);
           __Ctrl_Home   : Pom := Min;
           __Ctrl_end    : Pom := Max;
         end
    else case _Kt of
           __Prava_Sipka : Pom := Zvets(in_Num);
           __Leva_Sipka : Pom := Zmens(in_Num);
         end;

  if Pom <> in_Num
    then Spust(Pom, Min, Max, Typ_Zmen)
    else Typ_Edit_string.Zpracuj_Key(_Kt);
  Val(in_string^, Pomval, Code);
  if Code = 0
    then
      begin
        __Stav_Menu := __Stav_Menu or __Platna_Hodnota;
        if Pomval > Max
          then in_Num := Max
          else if Pomval < Min
                 then in_Num := Min
                 else in_Num := Pomval;

      end
    else if Otevreno
           then __Stav_Menu := __Stav_Menu and ($Ff xor __Platna_Hodnota)
           else Otevri;
end;

procedure Typ_Edit_Integer.Otevri;
begin
  __Stav_Menu :=  __Stary_Retez or __Stav_Menu;
  __Kursor    := Length(in_string^)+1;

  Prekresli;
  Typ_Menu.Otevri;
  Srovnej_Kursor;
end;

procedure Typ_Edit_Integer.Vytvor;
begin
  Typ_Edit_string.Vytvor(7, Cin, Cram, Czv, Typ);
end;

procedure Typ_Edit_Integer.Spust;
var S : Typ_Int_string;
begin
  in_Num := Defnum;
  Str(Defnum, S);
  Typ_Edit_string.Spust(S);
  Min := _Min;
  Max := _Max;
  Typ_Zmen := _Zmeny;
end;














procedure Typ_Menu.Pom_set(Co : Integer);begin end;

procedure Typ_Menu.Zpracuj_Key(_Kt : Word);begin end;

procedure Typ_Menu.Otevri;
begin
  Zobraz;
  __Stav_Menu := __Stav_Menu or __Otevreno;
  __Stav_Menu := __Stav_Menu and ($Ff xor __Platna_Hodnota);
end;

procedure Typ_Menu.Zavri;
begin
  Zhasni;
  __Stav_Menu := __Stav_Menu and ($Ff xor __Otevreno);
end;

function Typ_Menu.Out_Hodnota ;
begin
  Out_Hodnota := 0;
end;

function Typ_Menu.Platna : Boolean;
begin
  Platna := ((__Stav_Menu and __Platna_Hodnota) <> 0) end;

function Typ_Menu.Otevreno : Boolean;
begin
  Otevreno := ((__Stav_Menu and __Otevreno) <> 0) end;

function Typ_Menu.Potvrzeno : Boolean;
begin
  Potvrzeno := ((__Stav_Menu and __Potvrzena_Hodnota) <> 0) end;

constructor Typ_Menu.Init;
begin
  __Stav_Menu := 0;

  Typ_Vokynko.Init;
end;

function Typ_Menu.Out_Zobraz  : string;
begin
  Out_Zobraz := '';
end;



constructor Typ_Menu_Vyber.Init;
type Ptrstring = ^string;
var I : Word;
    Pomkon, Konpop : Integer;
    Pi : Typ_Pointer_Integer;
    Pv : Typ_Pointer_Vyber;
    Ps : Typ_Pointer_string;
    Xp, Yp, Zp : Typ_Souradnic;
    Pocitadlo : Typ_Souradnic;
    Popis, Poms : string;

  function Readint : Integer;
  var S : string[6];
      Pom, Pom2 : Integer;
  begin
    S := ' ';
    while Pompchar(Defpop)^[I] = ' ' do Inc(I);
    while Pompchar(Defpop)^[I] in ['0'..'9','-'] do
      begin
        S := S+Pompchar(Defpop)^[I];
        Inc(I);
      end;
    Val(S, Pom, Pom2);
    Readint := Pom;
  end;

  function Readsou : Typ_Souradnic;
  begin
    Readsou := Typ_Souradnic(Readint);
  end;

  function Readstr : string;
  var Delka : Byte;

  begin
    Delka := 0;
    while Pompchar(Defpop)^[I] = ' ' do Inc(I);
    while Pompchar(Defpop)^[I] <> '~' do
      begin
        Inc(Delka);
        Readstr[Delka] := Pompchar(Defpop)^[I];
        Inc(I);
      end;
    Inc(I);
    Readstr[0] := Char(Delka);
  end;

begin
  I := Odposice;
  Typ_Menu.Init;
  Typ_Menu.Presun(Readsou,Readsou,Readsou);
  __Colob := Readint;
  __Colzv := Readint;
  Barva   := Readint;

  Typ_Vokynko.Vytvor_Ram(Readint, Readint, __Colob, Barva, Strom_Ram);

  Pocet   := Readint;
  in_Num  := Readint;
  __Stav_Menu := __Stav_Menu or __Potvrzena_Hodnota;

  GetMem(Sub_Menu, Pocet*SizeOf(Typ_Pointer_Menu));


  Pocitadlo := 1;
  Konpop := 0;
  Popis := '';

  while Pocitadlo <= Pocet do
    begin

      Poms   := Readstr;
      Pomkon := Konpop;
      for Konpop := Pomkon to Konpop +Length(Poms) do
        Popis[Konpop] := Poms[Konpop-Pomkon];
      Inc(Konpop);

      while Pompchar(Defpop)^[I] = ' ' do Inc(I);
      case Pompchar(Defpop)^[I] of
        'V','v' : begin
                Inc(I);
                New(Pv,Init(Defpop, I));
                Sub_Menu^[Pocitadlo] := Pv
              end;
        'o','O' : begin
                    Inc(I);
                    New(Sub_Menu^[Pocitadlo], Init);
                    Sub_Menu^[Pocitadlo]^.Zavri;
                  end;

        's','S' : begin
                    Inc(I);
                    New(Ps,Init);
                    Ps^.Presun(Readsou,Readsou,Readsou);

                    Ps^.Vytvor(Readint, Readint,Readint,Readint, Strom_Ram);
                    Ps^.Spust(Readstr);
                    Sub_Menu^[Pocitadlo] := Ps;
                  end;
        'i','i' : begin
                    Inc(I);
                    New(Pi,Init);
                    Pi^.Presun(Readsou,Readsou,Readsou);
                    Pi^.Vytvor(Readint,Readint,Readint, Strom_Ram);
                    Pi^.Spust(Readint,Readint,Readint,Readint);
                    Sub_Menu^[Pocitadlo] := Pi;
                  end;
      end;
      Inc(Pocitadlo);
    end;
  GetMem(Oznaceni,Konpop+1);
  for Pomkon := 0 to Konpop do Oznaceni^[Pomkon] := Popis[Pomkon];
  Odposice := I;
end;

procedure Typ_Menu_Vyber.Pom_set;
begin
  in_Num := Co;
  __Stav_Menu := __Stav_Menu or __Potvrzena_Hodnota;
  Prekresli;
end;



procedure Typ_Menu_Vyber.Zpracuj_Key;
begin
  if (_Kt=__Return) and (not Otevreno) then Otevri
  else
  if Otevreno then
    begin
      if _Kt = __Return
        then __Stav_Menu := __Stav_Menu or __Potvrzena_Hodnota;
      if (Sub_Menu^[in_Num]^.Otevreno)
        then Sub_Menu^[in_Num]^.Zpracuj_Key(_Kt)
        else
          begin
            case _Kt of
              __Dolni_Sipka : begin
                                 __Stav_Menu := __Stav_Menu and( $Ff xor __Potvrzena_Hodnota);
                                 Inc(in_Num); if in_Num > Pocet then in_Num := 1 end;
              __Horni_Sipka : begin
                                 __Stav_Menu := __Stav_Menu and( $Ff xor __Potvrzena_Hodnota);
                                 Dec(in_Num); if in_Num < 1 then in_Num := Pocet end;
              __Esc         : Zavri;
              Word('4')     : L;
              Word('6')     : R;
              Word('8')     : U;
              Word('2')     : D;
              else Sub_Menu^[in_Num]^.Zpracuj_Key(_Kt);
            end;
{  crt.gotoxy(1,1);write(poloha.x,' ',poloha.y,' ',poloha.z);}
          end;
      Prekresli;
    end
  else
    case _Kt of
      __Prava_Sipka : begin
                       Inc(in_Num);
                       if in_Num > Pocet then in_Num := 1;
                       __Stav_Menu := __Stav_Menu or __Potvrzena_Hodnota;
                     end;
      __Leva_Sipka : begin
                        Dec(in_Num);
                        if in_Num < 1 then in_Num := Pocet;
                        __Stav_Menu := __Stav_Menu or __Potvrzena_Hodnota;
                      end;
    end;


end;

procedure Typ_Menu_Vyber.Prekresli;
type Pom_Typ = ^string;
var Zac : Byte;
    Popis : string;
    I : Typ_Souradnic;

begin
  Zac := 0;
  for I:=1 to Pocet do
    begin
      if I = in_Num
        then Psaci_Barva := __Colzv
        else Psaci_Barva := __Colob;
      GotoXY(1, I);
      Pis(Pom_Typ(@Oznaceni^[Zac])^);

      Popis := Sub_Menu^[I]^.Out_Zobraz;
      GotoXY(Rozmer.X - Length(Popis) -1, I);
      Pis(Popis);

      Line_Char_Lr(I, Byte(Oznaceni^[Zac])+1, Length(Popis)+2, ' ');
      Inc(Zac, Byte(Oznaceni^[Zac])+1);
    end;
end;

procedure Typ_Menu_Vyber.Otevri;
begin
  Typ_Menu.Otevri;
  Prekresli;
end;

procedure Typ_Menu_Vyber.Vm0;
var C : Word;
begin
  if KeyPressed then
    begin
      C := Byte(ReadKey);
      if C = 0 then  C := 256* Byte(ReadKey);
      Zpracuj_Key(C);
    end;
end;


function Typ_Menu_Vyber.Out_Hodnota;
begin
  if Potvrzeno then Out_Hodnota := in_Num
               else Out_Hodnota := 0;
end;

function Typ_Menu_Vyber.Out_Zobraz;
type Pom_Typ = ^string;
var Zac : Byte;
    I : Typ_Souradnic;
begin
  Zac := 0;
  for I := 2 to in_Num do
      Inc(Zac, Byte(Oznaceni^[Zac])+1);
  Out_Zobraz := Pom_Typ(@Oznaceni^[Zac])^
end;




begin
end.























var A : Typ_Menu_Vyber;
    B : Typ_Vokynko;

    C : Char;
    _in : Word;
    P : Pchar;
    I, J : Word;
const Cesta : array[1..4]of Typ_Instrukce = (Vm0, Jmpa, 0, Endc) ;

begin
  J := Length(Menudef)+Length(Menudef2);
  GetMem(P, J);
  for I := 0 to Length(Menudef) do
    P[I] := Menudef[I+1];
  for I := Length(Menudef)  to J-1 do
    P[I] := Menudef2[I-Length(Menudef)+1];


  _in := 0;
  Obrazovka.Nastav_mod(3+__Sada_3D_8X8);
  A.Init(P,_in);
  A.Otevri;
  A.Prekresli;

  A.Hejbej(Cesta,__Timer);
  __Timer.On;
  repeat
{    __timer.makej;}
  until (A.Potvrzeno and (A.in_Num = 6));
  __Timer.Off;

  B.Init
(__Nula_3D);
  B.Vytvor(20,4,12,12,Strom_Ram);
  B.Zobraz;
  repeat
    C := ReadKey;
    _in := Byte(C);
    if C = #0 then _in := Byte(ReadKey)*$100;
    A.Zpracuj_Key(_in);
    B.Clear;
    if A.Platna then
      begin
        B.GotoXY(1,1);
        B.Pis(A.Out_Zobraz);
      end
  until (A.Potvrzeno and (A.in_Num = 6));
end.
