unit
  Unpisbmp;
{ Tato jednotka slo pro vykreslen obrazovky VGA (80*50) }
{ do ernoblho BMP souboru. Soborm jsou postupn piazovan jmna }
{ kter maj von etzec (viz oznaceni v set_par_pisbmp), poadov }
{ slo (cislo_obr) a pponu BMP. }

interface
uses
  Obraz3D, Dos;

procedure On_Pisbmp;
procedure set_Par_Pisbmp(Oznaceni : NameStr; Odkud : Ptr_to_3D_Obrazovka);
procedure Off_Pisbmp;

implementation
uses
  Unhejb, Unfront, Crt;

type
  Typ_Zapis_Bmp = object(Typ_Hejbaci_Zaklad)
                    procedure Vm0;virtual;
                  end;
var
  Jmeno_file   : NameStr;
  Cislo_Obr    : Integer;
  Obrazovka    : Ptr_to_3D_Obrazovka;
  Psaci_Objekt : Typ_Zapis_Bmp;
  Psaci_Fronta : Typ_Hejb_Fronta_Intr;

procedure Typ_Zapis_Bmp.Vm0;
var S : string[8];
begin
  Sound(1500);       { uvodn zvuk }
  Delay(100);
  NoSound;
  Str(Cislo_Obr, S); { poadov slo zapisovanho obrzku }
  Obrazovka^.Zapis_Bmp(Jmeno_file+S+'.BMP');
  Inc(Cislo_Obr);
  Sound(200);
  Delay(100);
  NoSound;
end;

procedure On_Pisbmp;
const Prog : array[1..3]of Typ_Instrukce = (Vm0, Jmpa0,Endc);
begin
  Psaci_Objekt.Init;
  Psaci_Objekt.Hejbej(Prog); { Pi kadm piazen stroj. asu bude objekt provdt Vm0 }
  Psaci_Fronta.Init($05, False); { fronta je npchnuta na PrScr, piem pvon peruen se nevol }
  Psaci_Fronta.Zarad_Prvek(Psaci_Objekt);
  Psaci_Fronta.On;
end;

procedure Off_Pisbmp;
begin
  Psaci_Fronta.Zrus;  { poad fronta-objekt je nutn ! }
  Psaci_Objekt.Zrus;
end;

procedure set_Par_Pisbmp(Oznaceni : NameStr; Odkud : Ptr_to_3D_Obrazovka);
begin
  Jmeno_file := Oznaceni;
  if Odkud <> nil
    then Obrazovka := Odkud
    else Obrazovka := @Unhejb.Obrazovka;
  Cislo_Obr := 0;
end;

begin
  set_Par_Pisbmp('obr', @Unhejb.Obrazovka);
end.

