{ ************************ Program Dokola **************************** }
{ program se napchne jako rutina na peruen z klvesnice            }
{ a toto peruen hbe stle dokola objektem                          }
{ Kdo m v oblib Reset a nem Volkova, me odstranit sloen zvorky }
{ na konci programu                                                    }

{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,S+,V+,X+}
{$M 16384,30000,30000}
uses Unhejb, Unobdel, Unfront, Crt, Dos;
type Typ_Muj = object(Typ_Line)
                 procedure Vm0;virtual;
               end;

const Cesta : array[1..3]of Typ_Instrukce = ( Vm0, Jmpa0, endc );

var Dokola   : Typ_Muj;        { ten se bude hbat stle dokola }
    Klapka   : Typ_Hejb_Fronta_Intr; { fronta, kter se napchne na peruen z klvesnice }

procedure Typ_Muj.Vm0; { zvt hvzdu }
{ procedura, pokud je volna, to objektem pod dokola }
{ algoritmus vcelku bez komente }
const Smer  : (_L, _R, _U, _D) = _R;
const Prvni : Byte = 1;
begin
  Inc(Prvni);
  if (Prvni and 1) <> 0 then
    begin
      case Smer of
        _R : if Poloha.X+Rozmer.X < 79
               then R
               else Smer := _D;
        _D : if Poloha.Y+Rozmer.Y < Obrazovka.Y_Obr-1
               then D
               else Smer := _L;
        _L : if Poloha.X > 0
               then L
               else Smer := _U;
        _U : if Poloha.Y >0
               then U
               else Smer := _R;
      end;
    end;
end;


begin
  Dokola.Init;
  Dokola.Vytvor_string_Ram('DOKOLA',2,7,Obyc_Ram);
  Dokola.Zobraz;

  Klapka.Init($09, True);{ klapka je napojena na peruen z klvesnice }

  Dokola.Hejbej(Cesta);
  Klapka.Zarad_Prvek(Dokola);

  Klapka.On;

  ReadLn;

{  Keep(0);}

  klapka.zrus;
  dokola.zrus;
  konec;
end.
